\chapter{Project Plan}

\section{Project Estimate}
\subsection{Reconciled Estimate}
\begin{itemize}
    
    \item Hardware Cost: \\ Laptop with intel Core i7 processor
    \item Software Cost: \\ ChromaDB (open source) \\ BERT HuggingFace Transformer (open source) \\ Golang \\ Meta Llama-2 and LlamaIndex (open source)
    \item Development Cost: \\ Student team (3 members) working part time for 6 months \\ Data annotations, model training and website building efforts
    \item Other Cost: \\ Training materials and resources

\end{itemize}

\subsection{Project Resources}
\begin{itemize}

    \item Human Resources: \\ Student team (3 members) - Responsible for all aspects of the project including data annotations, model building, frontend development, backend development, and overall project implementation.
    \item Hardware Resources: \\ (Laptop specifications)
    \item Software Resources: \\ BERT (Bidirectional Encoder Representations from Transformer) - For recognizing custom Named Entity Recognition (NER) \\
    Meta Llama-2 - For classification of resumes based on job description \\ 
    ChromaDB - Vector Database
    \item Infrastructure Resources: \\ Cloud hosting or server infrastructure (for deployment)
    \item Other Resources: \\ Training material and resources for team
    
\end{itemize}

\section{Risk Management}
\subsection{Risk Identification}
This section will identify and list the potential risks associated with the project “Resume classification and Candidate Application Tracking System”. Some risks you may want to consider include:
\begin{enumerate}

    \item Technical Risk:
    \begin{itemize}
        \item Inaccurate or incomplete annotation of resume data for recognising custom Named Entity Recognition (NER) could lead to poor performance of NER model and inaccurate classification of resumes.
        \item The Chroma vector database may face scalability issues or performance bottlenecks as volume of data increases.
        \item NER model may not perform well on unseen data and fail to generalise well.
        \item Storing sensitive resume data in the database could expose it to security breaches or unauthorised access.
    \end{itemize}

    \item Data Risk:
    \begin{itemize}
        \item Storing and processing personal information from resumes may raise concerns about data privacy and compliance with regulations.
        \item Inconsistent and low quality resume data can affect the performance of NER model.
        \item Data loss or corruption due to hardware failures, software bugs could lead to loss of valuable resumes data.
    \end{itemize}

    \item Legal and Regulatory Risk:
    \begin{itemize}
        \item Unclear ownership rights or intellectual property issues could lead to disputes or legal complications.
        \item Potential legal issues related to privacy violations or incorrect alerts/fines.
    \end{itemize}

    \item Operational Risk:
    \begin{itemize}
        \item Unexpected system downtime could disrupt the recruitment process.
        \item Dependencies on third party services.
        \item Rapid growth in the volume of candidate applications or resumes data can lead to performance bottleneck.
    \end{itemize}

\end{enumerate}

\subsection{Risk Analysis}
Conducting a thorough risk analysis for the project is crucial as identification of risks is central for success and failure of the project. It also helps in identifying potential challenges and planning mitigation strategies. 
Risk analysis provides a comprehensive overview of potential risks and how they will be managed, ensuring a proactive approach to project management


\subsection{Overview of Risk Monitoring and Management}
\begin{enumerate}

    \item Risk Monitoring
    Continuous risk monitoring is crucial for identifying emerging risks and assessing the effectiveness of mitigation strategies.
    
    The project team will implement the following monitoring practices:
    \begin{itemize}
        \item Regular risks reviews
        \item Performance monitoring
        \item Compliance audits
        \item User feedback
        \item Security monitoring 
    \end{itemize}

    \item Risk Management Roles and Responsibilities:
    \begin{itemize}
        \item Assign a Risk Manager responsible for overseeing the risk management process, coordinating risk mitigation efforts, and reporting to project stakeholders.
        \item Establish a Risk Management Team comprising representatives from various project areas (e.g., technical, data, operations) to support the Risk Manager and contribute to risk identification, analysis, and mitigation.
        \item Clearly define risk management responsibilities for all project team members, ensuring accountability and ownership of specific risks.
    \end{itemize}

    \item Risk management
    \begin{itemize}
        \item Risk management plan
        \item Risk register
        \item Communication plan
        \item Continuous improvement
    \end{itemize}

    \item Risk Management Tools and Techniques:
    \begin{itemize}
        \item Implement risk audits and reviews at key project milestones to assess the effectiveness of risk mitigation strategies and identify new or emerging risks.
        \item Leverage risk analysis techniques, such as risk scoring, probability-impact matrices, and risk simulations, to quantify and prioritise risks.
    \end{itemize}
\end{enumerate}

\section{Project Schedule}
\subsection{Project Task Set}

\begin{enumerate}

    \item Project Planning and Initiation
    \begin{itemize}
        \item Define project scope and objectives
        \item Identify stakeholders and establish communication plan
        \item Conduct risk assessment and develop risk management plan
    \end{itemize}

    \item Requirements Gathering and Analysis
    \begin{itemize}
        \item Conduct user interviews and gather requirements
        \item Define system architecture and components
        \item Analyse data sources and integration requirements
        \item Develop functional and non-functional specifications
    \end{itemize}

    \item Design
    \begin{itemize}
        \item Design user interfaces and system workflows
    \end{itemize}

    \item Development and Implementation
    \begin{itemize}
        \item Set up development environment and infrastructure
        \item Manually annotated 100 resumes for recognition of named entities by AI model
        \item Develop AI model of extracting extracting named entities from resumes 
        \item Extracted named entities are then converted into vector embedding
        \item These vector embeddings are then stored into the vector database
        \item AI model is integrated with the vector database for retrieval of resumes as per requirement
        \item Development of web application and user interface
    \end{itemize}

    \item Testing and Quality Assurance
    \begin{itemize}
        \item Create test cases and test plans
        \item Perform unit testing, integration testing, and system testing
        \item Fix bugs and issues identified during testing
    \end{itemize}

    \item Deployment and Training
    \begin{itemize}
        \item Set up production environment and infrastructure
        \item Deploy the system in the target location
    \end{itemize}

    \item Project Monitoring and Control
    \begin{itemize}
        \item Conduct regular project status meetings
        \item Monitor project progress and update schedules
        \item Identify and address project risks and issues
    \end{itemize}

    \item Project Closure
    \begin{itemize}
        \item Conduct post-implementation review
        \item Document lessons learned and best practices
    \end{itemize}
\end{enumerate}

\subsection{Task Network}
\begin{figure}[!h]
    \centering   
    \includegraphics[width=15cm]{./images/tasknetwork.png}
    \caption{Task Network Diagram}
    \label{fig:enter-label}
\end{figure}

\newpage
\subsection{Timeline Chart}
\begin{figure}[!h]
    \centering
    \includegraphics[width=15cm]{./images/timelinechart.jpg}
    \caption{Timeline Chart}
    \label{fig:enter-label}
\end{figure}
